import { IRunnerOptions, ITaskFunction, ITasks, IStrategy, IDuration } from '../Interface';
export declare class CoreRunner<T = any> {
    static runnerCount: number;
    protected options: IRunnerOptions<T>;
    tasks: ITasks<T>;
    duration: IDuration;
    protected strategy: IStrategy<T>;
    protected __working: boolean;
    protected __isPaused: boolean;
    constructor(strategy: IStrategy<T>, options?: Partial<IRunnerOptions<T>>);
    isBusy(): boolean;
    protected setWorking(working: boolean): void;
    start(): boolean;
    add(task: ITaskFunction<T>, first?: boolean): number;
    addFirst(task: ITaskFunction<T>): number;
    addMultiple(tasks: ITaskFunction<T>[], first?: boolean): number;
    addMultipleFirst(tasks: ITaskFunction[]): number;
    remove(first?: boolean): ITaskFunction | undefined;
    removeFirst(): ITaskFunction | undefined;
    removeAt(index: number): ITaskFunction | undefined;
    removeRange(startIndex: number, endIndex: number): ITaskFunction[];
    removeAll(): ITaskFunction[];
}
